; 
    include \masm32\include\masm32rt.inc
; 
    ; ------------------------------------
    ; create a modeless dialog from the data
    ; written to the memory template.
    ; ------------------------------------
    ;       CallmodelessDialog MACRO Instance,Parent,DlgProc,lpExtra
    ;         invoke CreateDialogIndirectParam,Instance,esi,Parent,ADDR DlgProc,lpExtra
    ;         push eax                ;; preserve return value
    ;         invoke GlobalFree,esi   ;; free memory
    ;         pop eax                 ;; restore return value
    ;         pop edi
    ;         pop esi
    ;       ENDM

    .data
      hInstance dd    0
      hDlg      dd    0
      hdc       dd    0
      junk0     dd    0

      qwi       dd    0
      qhe       dd    0
      newcolor  dd    0
      iterate   dd    0

      msg       MSG   <>
      rc        RECT  <>

    .code
; 

DialogProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    SWITCH uMsg

      CASE WM_CTLCOLORDLG

        invoke GetStockObject, WHITE_BRUSH
        ret

      CASE WM_SIZE

        invoke InvalidateRgn, hwndDlg, NULL, TRUE

      CASE WM_CLOSE

        invoke DestroyWindow, hwndDlg

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Colored Pixels & Black Lines", \
           "FixedSys", 11, \
            WS_VISIBLE or WS_OVERLAPPEDWINDOW or \
            DS_CENTER, \
            0, \
            0,0,512,376, \
            1024 ;24064      ; original was 0,0,100,75,1024
                             ; the width,height are twice the values 512,376
                             ; not sure on the 24064

    ; What does the last parameter mean ( used 1024 from original )


    ; CallModelessDialog hInstance, 0, DialogProc, NULL

    invoke CreateDialogIndirectParam, hInstance,esi,0,ADDR DialogProc,NULL
    push eax
    invoke GlobalFree,esi
    pop eax
    pop edi
    pop esi


    mov hDlg, eax

    invoke GetDC, hDlg
    mov hdc, eax

    invoke Sleep, 1000

  msgLoop:

    invoke PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
    .IF msg.message != WM_QUIT
      .IF eax != 0
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
      .ELSE
        invoke GetClientRect, hDlg, ADDR rc
        invoke nrandom, rc.right
        mov ebx, eax
        invoke nrandom, rc.bottom
        mov esi, eax

        .if newcolor == 0
           invoke nrandom, 1 SHL 24  ; 24 bit for color using 1 SHL 8 ( 256 ) gives reds
           mov edi, eax
           inc newcolor
           invoke SetPixelV, hdc, ebx, esi, edi  ; x, y, c

           xor edx, edx
           mov ecx, rc.right
           mov eax, rc.bottom
           mul ecx
           shr eax, 5 ; 3 4
           or  eax, 1                         ; will be at least 1, side effect will always be odd
           mov iterate, eax
        .endif

        dec iterate
        .if iterate == 0
           mov newcolor, 0
        .endif

        .if iterate < 24 ; 256 64             ; only draw lines for last 24 (0..23) iterations of pixel color
           invoke LineTo, hdc, ebx, esi       ; unfortunately only black lines
        .endif
        invoke SetPixelV, hdc, ebx, esi, edi  ; x, y, c   colors any in 24 bit range
      .ENDIF
      jmp msgLoop
    .ENDIF

    invoke ExitProcess, eax

; 
end start